/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { ChatUserModel } from '../models';
import { ChatUsersModel } from '../models';
import { CreateChatUserCommand } from '../models';
import { LeavedGroupChannelsModel } from '../models';
import { UpdateChatUserCommand } from '../models';
/**
 * ChatUsersApi - axios parameter creator
 * @export
 */
export declare const ChatUsersApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary (Auth policies: RequireDoctorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersCurrentGet: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all chatUsers. (Auth policies: RequireDoctorRole)
     * @param {number} [limit]
     * @param {string} [token]
     * @param {string} [userIds]
     * @param {string} [nickname]
     * @param {string} [nicknameStartswith]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersGet: (limit?: number, token?: string, userIds?: string, nickname?: string, nicknameStartswith?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a chatUser. (Auth policies: RequireDoctorRole)
     * @param {CreateChatUserCommand} [createChatUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersPost: (createChatUserCommand?: CreateChatUserCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete chatUser. (Auth policies: RequireManagerRole)
     * @param {string} userId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdDelete: (userId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get chatUser. (Auth policies: RequireDoctorRole)
     * @param {string} userId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdGet: (userId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Leave from group channel (Auth policies: RequireManagerRole)
     * @param {string} userId
     * @param {string} [groupChannelUrl]
     * @param {number} [count]
     * @param {boolean} [dryRun]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdLeavePut: (userId: string, groupChannelUrl?: string, count?: number, dryRun?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update chatUser. (Auth policies: RequireDoctorRole)
     * @param {string} userId
     * @param {UpdateChatUserCommand} [updateChatUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdPut: (userId: string, updateChatUserCommand?: UpdateChatUserCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ChatUsersApi - functional programming interface
 * @export
 */
export declare const ChatUsersApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary (Auth policies: RequireDoctorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersCurrentGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>>;
    /**
     *
     * @summary Get all chatUsers. (Auth policies: RequireDoctorRole)
     * @param {number} [limit]
     * @param {string} [token]
     * @param {string} [userIds]
     * @param {string} [nickname]
     * @param {string} [nicknameStartswith]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersGet(limit?: number, token?: string, userIds?: string, nickname?: string, nicknameStartswith?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUsersModel>>;
    /**
     *
     * @summary Create a chatUser. (Auth policies: RequireDoctorRole)
     * @param {CreateChatUserCommand} [createChatUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersPost(createChatUserCommand?: CreateChatUserCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>>;
    /**
     *
     * @summary Delete chatUser. (Auth policies: RequireManagerRole)
     * @param {string} userId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdDelete(userId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get chatUser. (Auth policies: RequireDoctorRole)
     * @param {string} userId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdGet(userId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>>;
    /**
     *
     * @summary Leave from group channel (Auth policies: RequireManagerRole)
     * @param {string} userId
     * @param {string} [groupChannelUrl]
     * @param {number} [count]
     * @param {boolean} [dryRun]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdLeavePut(userId: string, groupChannelUrl?: string, count?: number, dryRun?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LeavedGroupChannelsModel>>;
    /**
     *
     * @summary Update chatUser. (Auth policies: RequireDoctorRole)
     * @param {string} userId
     * @param {UpdateChatUserCommand} [updateChatUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdPut(userId: string, updateChatUserCommand?: UpdateChatUserCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>>;
};
/**
 * ChatUsersApi - factory interface
 * @export
 */
export declare const ChatUsersApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary (Auth policies: RequireDoctorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersCurrentGet(options?: any): AxiosPromise<ChatUserModel>;
    /**
     *
     * @summary Get all chatUsers. (Auth policies: RequireDoctorRole)
     * @param {number} [limit]
     * @param {string} [token]
     * @param {string} [userIds]
     * @param {string} [nickname]
     * @param {string} [nicknameStartswith]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersGet(limit?: number, token?: string, userIds?: string, nickname?: string, nicknameStartswith?: string, options?: any): AxiosPromise<ChatUsersModel>;
    /**
     *
     * @summary Create a chatUser. (Auth policies: RequireDoctorRole)
     * @param {CreateChatUserCommand} [createChatUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersPost(createChatUserCommand?: CreateChatUserCommand, options?: any): AxiosPromise<ChatUserModel>;
    /**
     *
     * @summary Delete chatUser. (Auth policies: RequireManagerRole)
     * @param {string} userId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdDelete(userId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get chatUser. (Auth policies: RequireDoctorRole)
     * @param {string} userId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdGet(userId: string, options?: any): AxiosPromise<ChatUserModel>;
    /**
     *
     * @summary Leave from group channel (Auth policies: RequireManagerRole)
     * @param {string} userId
     * @param {string} [groupChannelUrl]
     * @param {number} [count]
     * @param {boolean} [dryRun]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdLeavePut(userId: string, groupChannelUrl?: string, count?: number, dryRun?: boolean, options?: any): AxiosPromise<LeavedGroupChannelsModel>;
    /**
     *
     * @summary Update chatUser. (Auth policies: RequireDoctorRole)
     * @param {string} userId
     * @param {UpdateChatUserCommand} [updateChatUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChatusersUserIdPut(userId: string, updateChatUserCommand?: UpdateChatUserCommand, options?: any): AxiosPromise<ChatUserModel>;
};
/**
 * Request parameters for apiV1ChatusersGet operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersGetRequest
 */
export interface ChatUsersApiApiV1ChatusersGetRequest {
    /**
     *
     * @type {number}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly limit?: number;
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly token?: string;
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly userIds?: string;
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly nickname?: string;
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly nicknameStartswith?: string;
}
/**
 * Request parameters for apiV1ChatusersPost operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersPostRequest
 */
export interface ChatUsersApiApiV1ChatusersPostRequest {
    /**
     *
     * @type {CreateChatUserCommand}
     * @memberof ChatUsersApiApiV1ChatusersPost
     */
    readonly createChatUserCommand?: CreateChatUserCommand;
}
/**
 * Request parameters for apiV1ChatusersUserIdDelete operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdDeleteRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdDelete
     */
    readonly userId: string;
}
/**
 * Request parameters for apiV1ChatusersUserIdGet operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdGetRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdGet
     */
    readonly userId: string;
}
/**
 * Request parameters for apiV1ChatusersUserIdLeavePut operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdLeavePutRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdLeavePutRequest {
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly userId: string;
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly groupChannelUrl?: string;
    /**
     *
     * @type {number}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly count?: number;
    /**
     *
     * @type {boolean}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly dryRun?: boolean;
}
/**
 * Request parameters for apiV1ChatusersUserIdPut operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdPutRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdPut
     */
    readonly userId: string;
    /**
     *
     * @type {UpdateChatUserCommand}
     * @memberof ChatUsersApiApiV1ChatusersUserIdPut
     */
    readonly updateChatUserCommand?: UpdateChatUserCommand;
}
/**
 * ChatUsersApi - object-oriented interface
 * @export
 * @class ChatUsersApi
 * @extends {BaseAPI}
 */
export declare class ChatUsersApi extends BaseAPI {
    /**
     *
     * @summary (Auth policies: RequireDoctorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    apiV1ChatusersCurrentGet(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ChatUserModel, any>>;
    /**
     *
     * @summary Get all chatUsers. (Auth policies: RequireDoctorRole)
     * @param {ChatUsersApiApiV1ChatusersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    apiV1ChatusersGet(requestParameters?: ChatUsersApiApiV1ChatusersGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ChatUsersModel, any>>;
    /**
     *
     * @summary Create a chatUser. (Auth policies: RequireDoctorRole)
     * @param {ChatUsersApiApiV1ChatusersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    apiV1ChatusersPost(requestParameters?: ChatUsersApiApiV1ChatusersPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ChatUserModel, any>>;
    /**
     *
     * @summary Delete chatUser. (Auth policies: RequireManagerRole)
     * @param {ChatUsersApiApiV1ChatusersUserIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    apiV1ChatusersUserIdDelete(requestParameters: ChatUsersApiApiV1ChatusersUserIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get chatUser. (Auth policies: RequireDoctorRole)
     * @param {ChatUsersApiApiV1ChatusersUserIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    apiV1ChatusersUserIdGet(requestParameters: ChatUsersApiApiV1ChatusersUserIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ChatUserModel, any>>;
    /**
     *
     * @summary Leave from group channel (Auth policies: RequireManagerRole)
     * @param {ChatUsersApiApiV1ChatusersUserIdLeavePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    apiV1ChatusersUserIdLeavePut(requestParameters: ChatUsersApiApiV1ChatusersUserIdLeavePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<LeavedGroupChannelsModel, any>>;
    /**
     *
     * @summary Update chatUser. (Auth policies: RequireDoctorRole)
     * @param {ChatUsersApiApiV1ChatusersUserIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    apiV1ChatusersUserIdPut(requestParameters: ChatUsersApiApiV1ChatusersUserIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ChatUserModel, any>>;
}
//# sourceMappingURL=chat-users-api.d.ts.map