/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateCurationCategoryCommand } from '../models';
import { CurationCategoriesModel } from '../models';
import { CurationCategoryModel } from '../models';
import { TranslateCurationCategoryCommand } from '../models';
import { UpdateCurationCategoryCommand } from '../models';
/**
 * CurationCategoriesApi - axios parameter creator
 * @export
 */
export declare const CurationCategoriesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdDelete: (curationCategoryId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get CurationCategory by id (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {string} languageCode
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdGet: (curationCategoryId: string, languageCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {UpdateCurationCategoryCommand} [updateCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdPut: (curationCategoryId: string, updateCurationCategoryCommand?: UpdateCurationCategoryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Translate CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {TranslateCurationCategoryCommand} [translateCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdTranslatePost: (curationCategoryId: string, translateCurationCategoryCommand?: TranslateCurationCategoryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all CurationCategories (Auth roles: Admin,Manager)
     * @param {string} languageCode
     * @param {string} [title]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesGet: (languageCode: string, title?: string, page?: number, limit?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a CurationCategory (Auth roles: Admin,Manager)
     * @param {CreateCurationCategoryCommand} [createCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesPost: (createCurationCategoryCommand?: CreateCurationCategoryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * CurationCategoriesApi - functional programming interface
 * @export
 */
export declare const CurationCategoriesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdDelete(curationCategoryId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get CurationCategory by id (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {string} languageCode
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdGet(curationCategoryId: string, languageCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationCategoryModel>>;
    /**
     *
     * @summary Update CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {UpdateCurationCategoryCommand} [updateCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdPut(curationCategoryId: string, updateCurationCategoryCommand?: UpdateCurationCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationCategoryModel>>;
    /**
     *
     * @summary Translate CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {TranslateCurationCategoryCommand} [translateCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdTranslatePost(curationCategoryId: string, translateCurationCategoryCommand?: TranslateCurationCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get all CurationCategories (Auth roles: Admin,Manager)
     * @param {string} languageCode
     * @param {string} [title]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesGet(languageCode: string, title?: string, page?: number, limit?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationCategoriesModel>>;
    /**
     *
     * @summary Create a CurationCategory (Auth roles: Admin,Manager)
     * @param {CreateCurationCategoryCommand} [createCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesPost(createCurationCategoryCommand?: CreateCurationCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationCategoryModel>>;
};
/**
 * CurationCategoriesApi - factory interface
 * @export
 */
export declare const CurationCategoriesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdDelete(curationCategoryId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get CurationCategory by id (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {string} languageCode
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdGet(curationCategoryId: string, languageCode: string, options?: any): AxiosPromise<CurationCategoryModel>;
    /**
     *
     * @summary Update CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {UpdateCurationCategoryCommand} [updateCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdPut(curationCategoryId: string, updateCurationCategoryCommand?: UpdateCurationCategoryCommand, options?: any): AxiosPromise<CurationCategoryModel>;
    /**
     *
     * @summary Translate CurationCategory (Auth roles: Admin,Manager)
     * @param {string} curationCategoryId
     * @param {TranslateCurationCategoryCommand} [translateCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesCurationCategoryIdTranslatePost(curationCategoryId: string, translateCurationCategoryCommand?: TranslateCurationCategoryCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get all CurationCategories (Auth roles: Admin,Manager)
     * @param {string} languageCode
     * @param {string} [title]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesGet(languageCode: string, title?: string, page?: number, limit?: number, options?: any): AxiosPromise<CurationCategoriesModel>;
    /**
     *
     * @summary Create a CurationCategory (Auth roles: Admin,Manager)
     * @param {CreateCurationCategoryCommand} [createCurationCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurationcategoriesPost(createCurationCategoryCommand?: CreateCurationCategoryCommand, options?: any): AxiosPromise<CurationCategoryModel>;
};
/**
 * Request parameters for apiV1CurationcategoriesCurationCategoryIdDelete operation in CurationCategoriesApi.
 * @export
 * @interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdDeleteRequest
 */
export interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdDelete
     */
    readonly curationCategoryId: string;
}
/**
 * Request parameters for apiV1CurationcategoriesCurationCategoryIdGet operation in CurationCategoriesApi.
 * @export
 * @interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdGetRequest
 */
export interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdGet
     */
    readonly curationCategoryId: string;
    /**
     *
     * @type {string}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdGet
     */
    readonly languageCode: string;
}
/**
 * Request parameters for apiV1CurationcategoriesCurationCategoryIdPut operation in CurationCategoriesApi.
 * @export
 * @interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdPutRequest
 */
export interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdPut
     */
    readonly curationCategoryId: string;
    /**
     *
     * @type {UpdateCurationCategoryCommand}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdPut
     */
    readonly updateCurationCategoryCommand?: UpdateCurationCategoryCommand;
}
/**
 * Request parameters for apiV1CurationcategoriesCurationCategoryIdTranslatePost operation in CurationCategoriesApi.
 * @export
 * @interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdTranslatePostRequest
 */
export interface CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdTranslatePostRequest {
    /**
     *
     * @type {string}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdTranslatePost
     */
    readonly curationCategoryId: string;
    /**
     *
     * @type {TranslateCurationCategoryCommand}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdTranslatePost
     */
    readonly translateCurationCategoryCommand?: TranslateCurationCategoryCommand;
}
/**
 * Request parameters for apiV1CurationcategoriesGet operation in CurationCategoriesApi.
 * @export
 * @interface CurationCategoriesApiApiV1CurationcategoriesGetRequest
 */
export interface CurationCategoriesApiApiV1CurationcategoriesGetRequest {
    /**
     *
     * @type {string}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesGet
     */
    readonly languageCode: string;
    /**
     *
     * @type {string}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesGet
     */
    readonly title?: string;
    /**
     *
     * @type {number}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesGet
     */
    readonly limit?: number;
}
/**
 * Request parameters for apiV1CurationcategoriesPost operation in CurationCategoriesApi.
 * @export
 * @interface CurationCategoriesApiApiV1CurationcategoriesPostRequest
 */
export interface CurationCategoriesApiApiV1CurationcategoriesPostRequest {
    /**
     *
     * @type {CreateCurationCategoryCommand}
     * @memberof CurationCategoriesApiApiV1CurationcategoriesPost
     */
    readonly createCurationCategoryCommand?: CreateCurationCategoryCommand;
}
/**
 * CurationCategoriesApi - object-oriented interface
 * @export
 * @class CurationCategoriesApi
 * @extends {BaseAPI}
 */
export declare class CurationCategoriesApi extends BaseAPI {
    /**
     *
     * @summary Delete CurationCategory (Auth roles: Admin,Manager)
     * @param {CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationCategoriesApi
     */
    apiV1CurationcategoriesCurationCategoryIdDelete(requestParameters: CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get CurationCategory by id (Auth roles: Admin,Manager)
     * @param {CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationCategoriesApi
     */
    apiV1CurationcategoriesCurationCategoryIdGet(requestParameters: CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurationCategoryModel, any>>;
    /**
     *
     * @summary Update CurationCategory (Auth roles: Admin,Manager)
     * @param {CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationCategoriesApi
     */
    apiV1CurationcategoriesCurationCategoryIdPut(requestParameters: CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurationCategoryModel, any>>;
    /**
     *
     * @summary Translate CurationCategory (Auth roles: Admin,Manager)
     * @param {CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationCategoriesApi
     */
    apiV1CurationcategoriesCurationCategoryIdTranslatePost(requestParameters: CurationCategoriesApiApiV1CurationcategoriesCurationCategoryIdTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get all CurationCategories (Auth roles: Admin,Manager)
     * @param {CurationCategoriesApiApiV1CurationcategoriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationCategoriesApi
     */
    apiV1CurationcategoriesGet(requestParameters: CurationCategoriesApiApiV1CurationcategoriesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurationCategoriesModel, any>>;
    /**
     *
     * @summary Create a CurationCategory (Auth roles: Admin,Manager)
     * @param {CurationCategoriesApiApiV1CurationcategoriesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationCategoriesApi
     */
    apiV1CurationcategoriesPost(requestParameters?: CurationCategoriesApiApiV1CurationcategoriesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurationCategoryModel, any>>;
}
//# sourceMappingURL=curation-categories-api.d.ts.map