/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CheckNotificationsCommand } from '../models';
import { NotificationCode } from '../models';
import { NotificationsModel } from '../models';
/**
 * NotificationsApi - axios parameter creator
 * @export
 */
export declare const NotificationsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Check notification. (Auth policies: RequireDoctorRole)
     * @param {CheckNotificationsCommand} [checkNotificationsCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1NotificationsCheckPost: (checkNotificationsCommand?: CheckNotificationsCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all notifications. (Auth policies: RequireDoctorRole)
     * @param {NotificationCode} [notificationCode]
     * @param {boolean} [unreadCountOnly]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1NotificationsGet: (notificationCode?: NotificationCode, unreadCountOnly?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * NotificationsApi - functional programming interface
 * @export
 */
export declare const NotificationsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Check notification. (Auth policies: RequireDoctorRole)
     * @param {CheckNotificationsCommand} [checkNotificationsCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1NotificationsCheckPost(checkNotificationsCommand?: CheckNotificationsCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get all notifications. (Auth policies: RequireDoctorRole)
     * @param {NotificationCode} [notificationCode]
     * @param {boolean} [unreadCountOnly]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1NotificationsGet(notificationCode?: NotificationCode, unreadCountOnly?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<NotificationsModel>>;
};
/**
 * NotificationsApi - factory interface
 * @export
 */
export declare const NotificationsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Check notification. (Auth policies: RequireDoctorRole)
     * @param {CheckNotificationsCommand} [checkNotificationsCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1NotificationsCheckPost(checkNotificationsCommand?: CheckNotificationsCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get all notifications. (Auth policies: RequireDoctorRole)
     * @param {NotificationCode} [notificationCode]
     * @param {boolean} [unreadCountOnly]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1NotificationsGet(notificationCode?: NotificationCode, unreadCountOnly?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<NotificationsModel>;
};
/**
 * Request parameters for apiV1NotificationsCheckPost operation in NotificationsApi.
 * @export
 * @interface NotificationsApiApiV1NotificationsCheckPostRequest
 */
export interface NotificationsApiApiV1NotificationsCheckPostRequest {
    /**
     *
     * @type {CheckNotificationsCommand}
     * @memberof NotificationsApiApiV1NotificationsCheckPost
     */
    readonly checkNotificationsCommand?: CheckNotificationsCommand;
}
/**
 * Request parameters for apiV1NotificationsGet operation in NotificationsApi.
 * @export
 * @interface NotificationsApiApiV1NotificationsGetRequest
 */
export interface NotificationsApiApiV1NotificationsGetRequest {
    /**
     *
     * @type {NotificationCode}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly notificationCode?: NotificationCode;
    /**
     *
     * @type {boolean}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly unreadCountOnly?: boolean;
    /**
     *
     * @type {number}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * NotificationsApi - object-oriented interface
 * @export
 * @class NotificationsApi
 * @extends {BaseAPI}
 */
export declare class NotificationsApi extends BaseAPI {
    /**
     *
     * @summary Check notification. (Auth policies: RequireDoctorRole)
     * @param {NotificationsApiApiV1NotificationsCheckPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationsApi
     */
    apiV1NotificationsCheckPost(requestParameters?: NotificationsApiApiV1NotificationsCheckPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get all notifications. (Auth policies: RequireDoctorRole)
     * @param {NotificationsApiApiV1NotificationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationsApi
     */
    apiV1NotificationsGet(requestParameters?: NotificationsApiApiV1NotificationsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<NotificationsModel, any>>;
}
//# sourceMappingURL=notifications-api.d.ts.map